﻿package {

	import flash.display.Sprite;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;

	public class Clock extends Sprite {

		private var myTimer:Timer;
		private var now:Date;
		private var hourcolor:String;
		private var minutecolor:String;
		private var secondcolor:String;
		private var angle:Number;
		public function Clock():void {
			chargeColor(null);
			startTimer();
			stage.addEventListener(MouseEvent.CLICK,chargeColor);
		}
		private function startTimer():void {
			myTimer= new Timer( 100, 0 );
			myTimer.addEventListener( TimerEvent.TIMER, updatehour );
			myTimer.start();

		}
		private function updatehour(Tevt:TimerEvent ) {
			if (Tevt.currentTarget.currentCount !=1) {
				while (numChildren>0) {
					removeChildAt(0);

				}
			}
			now = new Date();
			var heure:String = reglage( now.hours );
			var minute:String = reglage( now.minutes );
			var seconde:String = reglage( now.milliseconds );
			minutecolor =  buildColor();
			//hourcolor =  buildColor();
			shapeBuilder3(Number(heure.substring(0,2)),300,300,hourcolor);
			shapeBuilder(Number(minute.substring(0,2)),300,300,minutecolor);
			shapeBuilder2(Number(seconde.substring(0,2)),300,300,secondcolor);
		}
		private function reglage( valeur:uint ):String {
			return valeur < 10?"0" + valeur:String(valeur);
		}
		private function chargeColor(e:MouseEvent):void {
			hourcolor = buildColor();
			minutecolor = buildColor();
			secondcolor = buildColor();
		}
		private function buildColor():String {
			for (var j:uint=200; j<250; j++) {
				var R:uint = 255;
				var G:uint = 255;
				var B:uint = Math.round(Math.random()*j);
			}
			var nbr:uint =  R << 16 | G << 8 | B;
			return "0x" + nbr.toString(16);

		}
		private function shapeBuilder(nbr:uint,X:uint,Y:uint,color:String):void {

			var s1:Number = (now.seconds +(now.milliseconds /1000))*6;
			var m1:Number = (now.minutes +(s1 /360))*6;
			
			if(nbr == 0){
					angle = 360/2;
				}else if(nbr != 0){
					angle = 360/nbr;
				}

			var longueur:uint = 500;
			var myShape:Sprite = new Sprite();
			myShape.graphics.lineStyle(0,Number(color),.3);
			myShape.graphics.beginFill(Number(color),.5);
			for (var i:uint=0; i<360; i+=angle) {
				var posx:Number =Math.sin(Math.PI*i/180);
				var posy:Number =Math.sin(Math.PI*i/180);
			}
			myShape.graphics.moveTo(s1+100,0);
			myShape.graphics.lineTo(0,-s1/10);
			myShape.graphics.lineTo(0,+s1/10);
			myShape.graphics.moveTo(100,0)
			myShape.x=X;
			myShape.y=Y;
			myShape.rotation = 270+m1;
			addChild(myShape);
		}
		private function shapeBuilder3(nbr:uint,X:uint,Y:uint,color:String):void {

			var s1:Number = (now.seconds +(now.milliseconds /1000))*6;
			var m1:Number = (now.minutes +(s1 /360))*6;
			var h1:Number = (now.hours +(m1/360))*30;
			if(nbr == 0){
					angle = 360/2;
				}else if(nbr !=0){
					angle = 360/nbr;
				}
			var myShape:Sprite = new Sprite();
			myShape.graphics.lineStyle(60,Number(color),.3);
			myShape.graphics.beginFill(Number(color),.5);
			myShape.graphics.moveTo(s1,0);
			myShape.graphics.lineTo(s1+50,0);
			myShape.x=X;
			myShape.y=Y;
			myShape.rotation = 270+h1;
			addChild(myShape);
		}
		private function shapeBuilder2(nbr:uint,X:uint,Y:uint,color:String):void {
			var s1:Number = (now.seconds +(now.milliseconds /1000))*6;
			angle = 360/2;
			var myShape2:Sprite = new Sprite();
			myShape2.graphics.lineStyle(2,Number(color),.3);
			myShape2.graphics.lineTo(300,300);
			myShape2.x=X;
			myShape2.y=Y;
			myShape2.rotation = 225- s1;
			addChild(myShape2);
		}
	}
}